#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TurretCFG.h"
std::auto_ptr<Fish_TurretCFG> Fish_TurretCFG::msSingleton(nullptr);

int Fish_TurretCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretCFGData* Fish_TurretCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TurretCFGData>& Fish_TurretCFG::GetMapData()
{
	return mMapData;
}

void Fish_TurretCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TurretCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mColor = element->IntAttribute("Color");
		data.mSoundID = element->IntAttribute("SoundID");
		data.mFireEffectID = element->IntAttribute("FireEffectID");
		data.mEffectOffsetY = element->IntAttribute("EffectOffsetY");
		data.mOffsetY = element->IntAttribute("OffsetY");
		data.mFireOffsetY = element->IntAttribute("FireOffsetY");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TurretCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TurretCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TurretCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TurretCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "ResType", data.mResType);
		LuaCfgHelper::readString(L, "ResName", data.mResName);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "Color", data.mColor);
		LuaCfgHelper::readInt(L, "SoundID", data.mSoundID);
		LuaCfgHelper::readInt(L, "FireEffectID", data.mFireEffectID);
		LuaCfgHelper::readInt(L, "EffectOffsetY", data.mEffectOffsetY);
		LuaCfgHelper::readInt(L, "OffsetY", data.mOffsetY);
		LuaCfgHelper::readInt(L, "FireOffsetY", data.mFireOffsetY);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TurretCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TurretCFG* Fish_TurretCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretCFG());
	}
	return msSingleton.get();
}

void Fish_TurretCFG::Release()
{
	msSingleton.reset(nullptr);
}
